/*
 * surprises/uint-surprises.c --
 *
 * Surprises with unsigned integers (not only in C).
 */

#include <stdio.h>
#include <stdint.h>

int main()
{
    int max = 321;
    uint8_t n;

    n = UINT8_MAX;
    printf("%d\n", ++n);                /* 127 + 1 = 0 */

    n = 42;
    n += UINT8_MAX;
    printf("%d\n", ++n);                /* 42 + 127 = 42 */

    n -= UINT8_MAX;                     /* 42 - 127 = 42 */
    printf("%d\n", --n);

    for (n = 0; n < max; n++) {           /* endless loop */
        putchar('.');
    }
    putchar('\n');
    return 0;
}
